/*
 * Nombre del Proyecto:
     proy2.c
 * Nombre del Autor:
     (c) Mikroelektronika, 2009.
 * Description:
     El siguiente proyecto es desarrollado en lenguaje C y ejecuta dos programas:
"	Programa #1 que consiste en la lectura de los valores analgicos de un potencimetro colocado en la bornera de entrada analgica, presentando las variaciones de valores (en binario) en 8 LEDs y en dos DISPLAYs de 7 segmentos (en dos dgitos decimales) disponibles.
"	Programa #2 que consiste en LEDs Psicodlicos haciendo uso de los recursos de la tarjeta prototipo que consta de cuatro botoneras, 8 LEDs y dos DISPLAYs de 7 segmentos.

 * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC

*/
/*Header******************************************************/
int dec,uni,decimal,dato,aux;
int const disp[10]  = {0x3F, 0x06, 0x5B, 0x4F,                 //Se declaran como constantes
                       0x66, 0x6D, 0x7D, 0x07, 0x7F, 0x6F};   //Codigo Hexa para cada nuemro 
int const id[27] = {0X77,0X7C,0X39,0X5E,0x79,0x71,0x3d,0x76,0x06,0x1e,0x76,0x38,0x4F,0x54,0x55,0x5c,0x73,0x67,0x50,0x6d,0x70,0x1c,0x3e,0x4f,0x76,0x6e,0x5b};
                  // A  , B  , C  , D  , E  , F  , G  , H  , I  , J  , K  , L  , M  , N  ,   , O  , P  , Q  , R  , S  , T  , U  , V  , W  , X  , Y  , Z
                  // 0  , 1  , 2  , 3  , 4  , 5  , 6  , 7  , 8  , 9  , 10 , 11 ,12  ,13  ,14  ,15  ,16  ,17  ,18  ,19  ,20  ,21  ,22  ,23  ,24  ,25  ,26
int const giro[6] = {1,2,4,8,16,32};
int i=0;
                                  
int espejo(int temp1)                //Funcion Para invertir Bits de una variable
{ int temp2=0;
if ((temp1&0x01)==0x01)
temp2=temp2+128;
if ((temp1&0x02)==0x02)
temp2=temp2+64;
if ((temp1&0x04)==0x04)
temp2=temp2+32;
if ((temp1&0x08)==0x08)
temp2=temp2+16;
if ((temp1&0x10)==0x10)
temp2=temp2+8;
if ((temp1&0x20)==0x20)
temp2=temp2+4;
if ((temp1&0x40)==0x40)
temp2=temp2+2;
if ((temp1&0x80)==0x80)
temp2=temp2+1;
return temp2;
}

void p1()
{ 

ADC_Init();                                //inicializo el ADC
while(1)
{

dato=ADC_Read(0);       //entrada analogica 0

aux=(dato/10.23);                  //division perfecta para marcar rango 
if(aux<=99)
{
dec=aux/10;                       //division para extraer decimal del dato anterior
uni=aux%10;                      //modulo (residuo de la division) para extraer unidades
}
if(aux==100)
{
dec=0;
uni=0;
}
PORTB=espejo(aux);                // muestro el valor binario en el PORTB
PORTC=disp[uni];                // muestro valor unidaades en el PORTC.
PORTD=disp[dec];                // muestro valor decenas en el PORTD



}
}

void p2()
{
        //declaracion de variables

do{                                                                //se enceran displays
PORTC=disp[0];
PORTD=disp[0];
}while(PORTA.F2);                                // se valida que suelte la resistencia


while(1)
{if(PORTA.F1)                                        // si presiona la botonera PORTA.pin1
  {
  
  Delay_ms(300);
  while(!(PORTA)){
  PORTC=giro[0];                                // iniciales
  PORTD=giro[0];
  Delay_ms(500);
  PORTB=129;
  if(PORTA)
  break;
  PORTC=giro[1];                                // iniciales
  PORTD=giro[5];
  Delay_ms(500);
  PORTB=66;
  if(PORTA)
  break;
  PORTC=giro[2];                                // iniciales
  PORTD=giro[4];
  Delay_ms(500);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[3];                                // iniciales
  PORTD=giro[3];
  Delay_ms(500);
  PORTB=24;
  if(PORTA)
  break;
  PORTC=giro[4];                                // iniciales
  PORTD=giro[2];
  Delay_ms(500);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[5];                                // iniciales
  PORTD=giro[1];
 Delay_ms(500);
  PORTB=66;
  if(PORTA)
  break;
  
  }
  }

  if(PORTA.F2)                                        // si presiona la botonera PORTA.pin1
  {
  
  Delay_ms(300);
  while(!(PORTA)){
  PORTC=giro[0];                                // iniciales
  PORTD=giro[0];
  Delay_ms(350);
  PORTB=129;
  if(PORTA)
  break;
  PORTC=giro[1];                                // iniciales
  PORTD=giro[5];
  Delay_ms(350);
  PORTB=66;
  if(PORTA)
  break;
  PORTC=giro[2];                                // iniciales
  PORTD=giro[4];
  Delay_ms(350);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[3];                                // iniciales
  PORTD=giro[3];
  Delay_ms(350);
  PORTB=24;
  if(PORTA)
  break;
  PORTC=giro[4];                                // iniciales
  PORTD=giro[2];
  Delay_ms(350);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[5];                                // iniciales
  PORTD=giro[1];
 Delay_ms(350);
  PORTB=66;
  if(PORTA)
  break;
  
  }
  }

 if(PORTA.F3)                                        // si presiona la botonera PORTA.pin1
  {
  
  Delay_ms(300);
  while(!(PORTA)){
  PORTC=giro[0];                                // iniciales
  PORTD=giro[0];
  Delay_ms(200);
  PORTB=129;
  if(PORTA)
  break;
  PORTC=giro[1];                                // iniciales
  PORTD=giro[5];
  Delay_ms(200);
  PORTB=66;
  if(PORTA)
  break;
  PORTC=giro[2];                                // iniciales
  PORTD=giro[4];
  Delay_ms(200);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[3];                                // iniciales
  PORTD=giro[3];
  Delay_ms(200);
  PORTB=24;
  if(PORTA)
  break;
  PORTC=giro[4];                                // iniciales
  PORTD=giro[2];
  Delay_ms(200);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[5];                                // iniciales
  PORTD=giro[1];
 Delay_ms(200);
  PORTB=66;
  if(PORTA)
  break;
  
  }
  }

  if(PORTA.F4)                                        // si presiona la botonera PORTA.pin1
  {
  
  Delay_ms(300);
  while(!(PORTA)){
  PORTC=giro[0];                                // iniciales
  PORTD=giro[0];
  Delay_ms(50);
  PORTB=129;
  if(PORTA)
  break;
  PORTC=giro[1];                                // iniciales
  PORTD=giro[5];
  Delay_ms(50);
  PORTB=66;
  if(PORTA)
  break;
  PORTC=giro[2];                                // iniciales
  PORTD=giro[4];
  Delay_ms(50);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[3];                                // iniciales
  PORTD=giro[3];
  Delay_ms(50);
  PORTB=24;
  if(PORTA)
  break;
  PORTC=giro[4];                                // iniciales
  PORTD=giro[2];
  Delay_ms(50);
  PORTB=36;
  if(PORTA)
  break;
  PORTC=giro[5];                                // iniciales
  PORTD=giro[1];
 Delay_ms(50);
  PORTB=66;
  if(PORTA)
  break;
  
  }
  }

  
  }
}


void main()
{
ANSEL=0x01;
ANSELH = 0;                 // Configure other AN pins as digital I/O
C1ON_bit = 0;               // Disable comparators
C2ON_bit = 0;
TRISA  = 0xFF;              // PORTA como entrada
TRISC  = 0;                 // PORTC como salida
TRISB  = 0;                 // PORTB como salida
TRISD  = 0;                                        // PORTD como salida

PORTB=0;                                        // inicializado en 0 el PORTB

while(1)
{
PORTC=id[22];                                // iniciales
PORTD=id[9];                                // iniciales
PORTB=0;

if(RA1_bit=1)                                //prueba el bit 1 del PORTA
p1();
if(PORTA.F2=1)                                //prueba el bit 2 del PORTA
p2();
}

}